Package: rconfig
Type: Package
Title: Manage R Configuration at the Command Line
Version: 0.3.0
Date: 2023-06-26
Authors@R: c(
  person(given = "Peter",
    family = "Solymos",
    comment = c(ORCID = "0000-0001-7337-1740"),
    role = c("aut", "cre"),
    email = "peter@analythium.io"),
  person(given = "Analythium Solutions Inc.",
    role = c("cph", "fnd")))
Description: Configuration management using files (YAML, JSON, INI, TXT),
  JSON strings, and command line arguments. Command line arguments
  can be used to override configuration. Period-separated command line
  flags are parsed as hierarchical lists. Environment variables, R global variables,
  and configuration values can be substituted.
License: MIT + file LICENSE
LazyLoad: yes
Imports: yaml, jsonlite
RoxygenNote: 7.2.3
Encoding: UTF-8
BugReports: https://github.com/analythium/rconfig/issues
URL: https://github.com/analythium/rconfig
Language: en-US
NeedsCompilation: no
Packaged: 2023-06-27 04:34:09 UTC; Peter
Author: Peter Solymos [aut, cre] (<https://orcid.org/0000-0001-7337-1740>),
  Analythium Solutions Inc. [cph, fnd]
Maintainer: Peter Solymos <peter@analythium.io>
Repository: CRAN
Date/Publication: 2023-06-27 10:30:02 UTC
Built: R 4.6.0; ; 2026-04-25 21:36:42 UTC; unix

#!/usr/bin/env Rscript
CONFIG <- rconfig::rconfig()

SILENT <- rconfig::value(CONFIG$silent, FALSE)

model <- function() {
    if (!SILENT)
        message("Model ...")
    # your logic comes here
}

pred <- function() {
    if (!SILENT)
        message("Predict ...")
    # your logic comes here
}

main <- function() {
    cmd <- rconfig::command(CONFIG)
    if (length(cmd) == 0L)
        stop("Specify a command.", call. = FALSE)
    if (cmd[1L] == "model") {
        model()
    } else if (cmd[1L] == "predict") {
        pred()
    } else {
        stop("Command ", cmd, " not found.", call. = FALSE)
    }
}

main()

#!/usr/bin/env Rscript

library(plumber)
library(rconfig)
CONFIG <- rconfig()
TEST <- value(CONFIG$test, FALSE)
message("Mode: ", if (TEST) "Test" else "Prod")

pr("handler.R") |>
    pr_run(
        port = value(CONFIG$port, 8080)
    )

#!/usr/bin/env Rscript
CONFIG <- rconfig::rconfig()
verbose <- rconfig::value(CONFIG$verbose, FALSE)
if (verbose)
    message(Sys.time(), " - Started")
species <- CONFIG$species
if (is.null(species))
    stop("Species not provided", call. = FALSE)
if (!(species %in% iris$Species))
    stop("Provide a valid species")
if (verbose)
    message("Getting summaries for species ", species)
summary(iris[iris$Species == species, 1:4])
if (verbose)
    message(Sys.time(), " - Done")

#              a is set & not null             a set but null                  a is unset           implement
# ${a:-b}      substitute a                    substitute b                    substitute b         Yes
# ${a-b}       substitute a                    substitute null                 substitute b         Yes
# ${a:?b}      substitute a                    error, exit                     error, exit          Yes
# ${a?b}       substitute a                    substitute null                 error, exit          Yes

## process a length 1 char value
split_param <- function(x) {
    # r <- gregexpr("(:\\=|:\\+|:\\-|:\\?|\\=|\\+|\\-|\\?)", x)[[1L]]
    r <- gregexpr("(:\\-|:\\?|\\-|\\?)", x)[[1L]]
    i1 <- as.integer(r)
    i2 <- i1 + attr(r, "match.length") -1L
    sep <- substr(x, i1, i2)
    if (sep == "") {
        o <- c(x, "", "")
    } else {
        w <- strsplit(x, sep, fixed = TRUE)[[1L]]
        if (length(w) < 2L) {
            w <- c(w, "")
        }
        o <- c(w[1L], sep, w[2L])
    }
    o
}
inspect_char <- function(x) {
    if (length(x) != 1L)
        stop("Length must be 1")
    s <- strsplit(gsub("(\\$|\\#|\\@)\\{([^}]+)\\}", "___SPLIT___", x), "___SPLIT___", fixed = TRUE)[[1L]]
    if (!length(s) || identical(x, s))
        return(NULL)
    r <- gregexpr("(\\$|\\#|\\@)\\{([^}]+)\\}", x)[[1L]]
    i1 <- as.integer(r)
    i2 <- i1 + attr(r, "match.length") -1L
    v <- sapply(seq_along(i1), function(i) substr(x, i1[i] + 2L, i2[i] - 1L))
    q <- sapply(seq_along(i1), function(i) substr(x, i1[i], i1[i]))
    w <- t(sapply(v, split_param))
    colnames(w) <- c("par", "sep", "alt")
    m <- cbind(type = q, w, val = "")
    attr(m, "input") <- x
    attr(m, "split") <- s
    m
}


get_value_conf <- function(name, x, flat = FALSE) {
    if (flat)
        rconfig:::flatten_list(x)[[name]] else x[[name]]
}
get_value_env <- function(name) {
    o <- Sys.getenv(x = name, unset = NA)
    if (is.na(o))
        NULL else o
}
get_value_renv <- function(name) {
    o <- try(get(name, envir = .GlobalEnv), silent = TRUE)
    if (inherits(o, "try-error"))
        NULL else o
}

eval_param <- function(d) {
    if (is.null(d))
        return(d)
    n <- nrow(d)
    for (j in seq_len(n)) {
        pj <- switch(d[j,"type"],
            "$" = get_value_env(d[j,"par"]),
            "#" = get_value_conf(d[j,"par"], x, flat = FALSE),
            "@" = get_value_renv(d[j,"par"]))
        # par set but null (i.e. "")
        if (!is.null(pj) && identical(pj, "")) {
            if (grepl(":", d[j,"sep"])) {
                if (d[j, "sep"] == ":-") {
                    pj <- d[j, "alt"]
                } else {
                    stop(d[j, "alt"], call. = FALSE)
                }
            }
        }
        # par is unset (i.e. NULL)
        if (is.null(pj)) {
            if (d[j, "sep"] %in% c(":-", "-")) {
                pj <- d[j, "alt"]
            } else {
                stop(d[j, "alt"], call. = FALSE)
            }
        }
        # otherwise par is set and is not null (!= "")
        d[j, "val"] <- pj
    }
    d
}

substitute_list <- function(x) {
    fx <- rconfig:::flatten_list(x)
    nam <- names(fx)[sapply(fx, is.character)]
    X <- list()
    for (i in nam) {
        X[[i]] <- lapply(fx[[i]], inspect_char)
        for (k in seq_along(X[[i]])) {
            pk <- eval_param(X[[i]][[k]])
            if (!is.null(pk)) {
                v1 <- attr(pk, "split")
                v2 <- pk[,"val"]
                if (length(v2) < length(v1))
                    v2 <- c(v2, "")
                attr(pk, "subst") <- paste0(v1, v2, collapse="")
                X[[i]][[k]] <- pk
                fx[[i]][k] <- attr(pk, "subst")
            }
        }
    }
    o <- rconfig:::nest(fx)
    attributes(o) <- attributes(x)
    o
}

# Variable substitution

#              a is set & not null             a set but null                  a is unset           implement
# ${a:-b}      substitute a                    substitute b                    substitute b         Yes
# ${a-b}       substitute a                    substitute null                 substitute b         Yes
#
# ${a:=b}      substitute a                    assign b                        assign b             No
# ${a=b}       substitute a                    substitute null                 assign b             No
#
# ${a:?b}      substitute a                    error, exit                     error, exit          Yes
# ${a?b}       substitute a                    substitute null                 error, exit          Yes
#
# ${a:+b}      substitute b                    substitute null                 substitute null      No
# ${a+b}       substitute b                    substitute b                    substitute null      No


# What we look for
# `${VARIABLE}`: use environment variables in your shell to populate values
# `$VARIABLE` is NOT supported
# Extended shell-style features, such as `${VARIABLE/foo/bar}`, are not supported
#
# Provide inline default values using typical shell syntax:
#    ${VARIABLE:-default} evaluates to default if VARIABLE is unset or empty in the environment.
#    ${VARIABLE-default} evaluates to default only if VARIABLE is unset in the environment.
#
# Specify mandatory variables:
#    ${VARIABLE:?err} exits with an error message containing err if VARIABLE is unset or empty in the environment.
#    ${VARIABLE?err} exits with an error message containing err if VARIABLE is unset in the environment.
#

# Best summary: https://pubs.opengroup.org/onlinepubs/9699919799/utilities/V3_chap02.html#tag_18_06_02

# ${parameter:-word}
#    If parameter is unset or null, the expansion of word is substituted. Otherwise, the value of parameter is substituted. 
# ${parameter:+word}
#    If parameter is null or unset, nothing is substituted, otherwise the expansion of word is substituted.
# ${parameter:=word}
#    If parameter is unset or null, the expansion of word is assigned to parameter. The value of parameter is then substituted. 
# ${parameter:?word}
#    If parameter is null or unset, the expansion of word (or a message to that effect if word is not present) is written to the standard error and the shell, if it is not interactive, exits. Otherwise, the value of parameter is substituted. 



# What we substitute


# how we traverse the whole CONFIG for substituting dotted variables, e.g. value.node based on the config itself

x <- "This is ${VAL} for sure. Plus #{FOO} and @{BAR} too."
inspect_char(x)
x <- c("a ${AAA} and ", "b #{bBb}", "c @{CcC}")
lapply(x, inspect_char)
x <- c("${a:-b}", "${a:=b}", "${a:+b}", "${a:?err}")
lapply(x, inspect_char)

x <- "This is ${VAL:-val} for sure, but not ${VAX-vax}. Plus #{FOO?err}, #{FEE:-}, and @{BAR} too."
inspect_char(x)


# next function can 
# - take known values from env,config,baseenv
# - evaluate based on output matrix
# - put it back together and assign to the config list or throw error




cf <- rconfig::rconfig(file = "inst/examples/rconfig-sub.yml")
cat(readLines("inst/examples/rconfig-prod.yml"), sep="\n")
fcf <- rconfig:::flatten_list(cf)
ncf <- rconfig:::nest(fcf)
attributes(ncf) <- attributes(cf)
identical(cf, ncf)

str(cf)
str(fcf)
str(ncf)

get_value_conf("unset", cf)
get_value_conf("this-is-null", cf)
get_value_conf("user.name", cf)

rm(a)
get_value_renv("a")
a=2
get_value_renv("a")
rm(a)
get_value_renv("a")

get_value_env("AAA")
Sys.setenv(AAA=12)
get_value_env("AAA")
Sys.setenv(AAA="")
get_value_env("AAA")
Sys.unsetenv("AAA")
get_value_env("AAA")


inspect_char("${A}")
inspect_char("${A} before")
inspect_char("after ${A}")
inspect_char("after ${A} before")

Sys.setenv(USER="Adele")
Sys.setenv(ACCESS="admin")
Type <- "simple"
Lang <- "HU"
x <- rconfig::rconfig(file = "inst/examples/rconfig-sub.yml")
str(x)
str(rconfig::substitute_list(x))


#              a is set & not null             a set but null                  a is unset           implement
# ${a:-b}      substitute a                    substitute b                    substitute b         Yes
# ${a-b}       substitute a                    substitute null                 substitute b         Yes
# ${a:?b}      substitute a                    error, exit                     error, exit          Yes
# ${a?b}       substitute a                    substitute null                 error, exit          Yes

#* Echo back the input
#* @param msg The message to echo
#* @post /echo
function(msg="") {
    list(msg = paste0(
        value(CONFIG$title, "The message is"),
        ": '", msg, "'"))
}

#* Return tets or prod mode
#* @get /test
function() {
    list(mode = if (TEST) "test" else "prod")
}

devtools::check()
devtools::install()
source("R/parsers.R")
source("R/types.R")
source("R/config.R")

str(rconfig::rconfig())

str(rconfig::rconfig(list = list(a = 1)))

cfile <- function(file) {
    system.file("examples", file, package = "rconfig")
}

str(rconfig::rconfig(file = cfile("rconfig.yml")))

str(rconfig::rconfig(file = cfile("rconfig.yml")))
str(rconfig::rconfig(file = cfile("rconfig-prod.yml")))

str(rconfig::rconfig(file = c(
    cfile("rconfig.yml"),
    cfile("rconfig-prod.yml"))))

str(rconfig::rconfig(file = c(
    cfile("rconfig.yml"),
    cfile("rconfig-prod.yml")),
    list = list(user = list(name = "Jack"))))

str(rconfig::rconfig(file = "https://raw.githubusercontent.com/analythium/docker-compose-shiny-example/main/docker-compose.yml"))

## json file
str(rconfig::rconfig(file = cfile("rconfig.json")))
str(rconfig::rconfig(file = cfile("rconfig-prod.json")))
str(rconfig::rconfig(file = c(
    cfile("rconfig.json"),
    cfile("rconfig-prod.json"))))

## text file
str(rconfig::rconfig(file = cfile("rconfig.txt")))
str(rconfig::rconfig(file = cfile("rconfig-prod.txt")))
str(rconfig::rconfig(file = c(
    cfile("rconfig.txt"),
    cfile("rconfig-prod.txt"))))

## cmd line: default config via R_RCONFIG_FILE

## cmd line --file

## cmd line --json

## cmd line default + args

## cmd line multiple files & args override

## check evaluating expressions
options("rconfig.eval"=FALSE)
str(rconfig::rconfig(file = cfile("rconfig.yml")))
str(rconfig::rconfig(file = cfile("rconfig.json")))
options("rconfig.eval"=NULL)
str(rconfig::rconfig(file = cfile("rconfig.yml")))
str(rconfig::rconfig(file = cfile("rconfig.json")))

## write some tips

## how to make sure type conversion is not mixed up
## detail what counts for parsing
## dot in names
## quotes in expressions for text parser: avoid double quotes
## when sep appears in value ("ab=4df")

## --- etc

yaml::yaml.load_file(x,
            eval.expr = FALSE,
            handlers = list(expr = function(x) paste0("!expr ", x))
            )

# note: prop is dropped where value is NULL, e.g. getOption("mc.cores")
options("rconfig.eval"=NULL)
rconfig:::parse_yml(cfile("rconfig.yml")) |>
    jsonlite::toJSON(auto_unbox = TRUE, pretty = TRUE)


#Rscript inst/examples/test.R

#cd inst/examples
#Rscript test.R

#R_RCONFIG_DEBUG="FALSE" Rscript test.R

#R_RCONFIG_FILE="rconfig-prod.yml" Rscript test.R

#R_RCONFIG_FILE="rconfig-prod.yml" R_RCONFIG_DEBUG="FALSE" Rscript test.R

#Rscript test.R -f rconfig-prod.yml --user.name "unreal_Zh5z*$#="

#Rscript test.R -j '{"trials":30,"dataset":"full-data.csv","user":{"name": "real_We4$#z*="}}' --user.name "unreal_Zh5z*$#="

#export USER=Jane
#Rscript test.R --user.name $USER

## Using alongside config

options("rconfig.debug"=TRUE)
conf <- config::get(
    config = "production",
    file = cfile("config.yml"),
    use_parent = FALSE)

str(rconfig::rconfig(
    file = cfile("rconfig.yml"),
    list = conf))


## assume here that the root of x1 and x2 are the same
## and we want that part (reversing unique naming side effects)
findroot <- function(x1, x2) {
    n1 <- nchar(x1)
    n2 <- nchar(x2)
    out <- character(0)
    for (i in seq_len(min(n1, n2))) {
        if (identical(substr(x1, i, i), substr(x2, i, i))) {
            out <- paste0(out, substr(x1, i, i))
        } else break
    }
    out
}
x1 <- "a.b.c9"
x2 <- "a.b.c10"
findroot(x1, x2)

x <- list(
    user=list(name="Joe"),
    cores=2,
    a=list(b=list(c=c(22,44)), d="q"))

flatten_list(x)

str(rconfig::rconfig(file = cfile("rconfig.yml")))
str(rconfig::rconfig(file = cfile("rconfig.yml"),
    list = x))

str(rconfig::rconfig(file = cfile("rconfig.yml"), flatten=TRUE))
str(rconfig::rconfig(file = cfile("rconfig.yml"),
    list = x, flatten=TRUE))


x <- list(
    user=list(name="Joe"),
    cores=2,
    a=list(b=list(c=c(22,44, 66)), d="q"))

str(x)
str(as.list(unlist(x), as.list))

str(x)
str(flatten_list(x))
identical(x, nest(flatten_list(x)))

x <- list(
    user=list(name="Joe"),
    cores=2,
    a=list(b.x=list(c=c(22,44, 66)), d.x="q"))
str(x)
str(as.list(unlist(x), as.list))
str(flatten_list(x))
str(x)
str(flatten_list(x, check=FALSE))

x <- list(
    user=list(name="Joe"),
    cores=2,
    a=list(b.c=list(d="b.c$d"), b=list(c.d="b$c.d")))


## make random lists

make_new_list <- function(n=10, maxdepth=3, m=10) {
    parts <- strsplit(unique(replicate(n, {
        paste0(sample(letters[seq_len(m)],
                      sample(maxdepth, 1), replace=TRUE), collapse=".")
    })), "\\.")
    values <- lapply(seq_along(parts), function(i) {
        ty <- sample(c("num", "int", "bool", "chr"), 1)
        v <- switch(ty,
            "bool"=c(TRUE, FALSE),
            "int"=1:100,
            "num"=rnorm(100),
            "chr"=letters)
        s <- sample(1:3, 1, prob = c(4, 2, 1))
        sample(v, s, replace=TRUE)
    })
    make_list(parts, values)
}

for (i in 1:1000) {
    x <- make_new_list(n=10, maxdepth=10, m=5)

    xi <- rconfig:::flatten_list(x, check=FALSE)
    ix <- rconfig:::nest(xi)
    if (!identical(x, ix))
        stop("Flatten/nest failed:\n\n", x)
}

str(x)
str(xi)
str(ix)



rconfig::rconfig(
    file = c(cfile("rconfig.json"),
             cfile("rconfig-prod.txt")),
    list = list(user = list(name = "Jack")),
    flatten = TRUE)

## lists for testing
x <- list(
    k = 0.51,
    t = list(
        r = list(
            b = c(FALSE, TRUE, TRUE))),
    l1 = -1,
    l = c(85L, 35L))

x <- list(
    x = c(0.27, -1.21),
    v = list(d = c(-0.49, -0.22)),
    p = list(w = 0.86))

x <- list(f = FALSE, i = FALSE, z = -0.78)

x <- list(
    s = list(x = list(g = c("v", "o"))),
    l = list(e = list(g = c("z", "l"))))

x <- list(
    h = list(s = list(k = "o"), f = c(TRUE, TRUE)),
    u = list(n = list(s = c("q", "a", "z"))))

x <- list(n = list(q = FALSE, z = list(u = FALSE)),
    f = list(z = list(t = 0.13)))

#!/usr/bin/env Rscript

library(shiny)
library(rconfig)
CONFIG <- rconfig()
TEST <- value(CONFIG$test, FALSE)
message("Mode: ", if (TEST) "Test" else "Prod")

ui <- fluidPage(
    mainPanel(
        h1(value(CONFIG$title, "Hello Shiny!")),
        sliderInput("obs",
            "Number of observations",
            min = 1,
            max = 5000,
            value = value(CONFIG$value, 100)),
        plotOutput("distPlot")
    )
)
server <- function(input, output) {
    output$distPlot <- renderPlot({
        dist <- rnorm(input$obs)
        hist(dist,
            col=value(CONFIG$color, "purple"),
            xlab="Random values")
    })
}
shinyApp(
    ui = ui,
    server = server,
    options = list(
        port = value(CONFIG$port, 8080)
    )
)

#!/usr/bin/env Rscript
CONFIG <- rconfig::rconfig()
verbose <- rconfig::value(CONFIG$verbose, FALSE)
if (verbose)
    message(Sys.time(), " - Started")
vars <- rconfig::value(
    CONFIG$vars,
    colnames(mtcars)[-1L])
if (any(!(vars %in% colnames(mtcars)[-1L])))
    stop("Not valid variable")
coef(lm(mpg ~ ., mtcars[,c("mpg", vars)]))
if (verbose)
    message(Sys.time(), " - Done")

#!/usr/bin/env Rscript

#' Usage:
#'
#' Rscript iris_rlog.R --species virginica > iris.log 2>&1
#' Rscript iris_rlog.R > iris.log 2>&1
#' Rscript iris_rlog.R --species maxima > iris.log 2>&1
#'
#' Rscript iris_rlog.R --species virginica > iris.log 2> iris.err
#' Rscript iris_rlog.R > iris.log 2> iris.err
#' Rscript iris_rlog.R --species maxima > iris.log 2> iris.err
#'
#' Note: this script requires the rlog package

info <- function(...) {
    rlog::log_info(paste(...))
}
error <- function(...) {
    rlog::log_error(paste(...))
    if (!interactive())
        q(status = 1)
}
abort <- function(...) {
    error(geterrmessage())
}
options(digits.secs = 3, error = abort)
CONFIG <- rconfig::rconfig()

info("Started")

species <- rconfig::value(
    CONFIG$species,
    error("Species not provided")) # anticipated error

## Make invalid species names a non-anticipated error
# if (!(species %in% iris$Species))
#     error("Provide a valid species")

info("Getting summaries for species", species)
summary(iris[iris$Species %in% species, 1:4])

info("Done")

q(status = 0)
